local StoneGate = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/basic/basicSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register Aligned Small Gate materials
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Materials/redRoof", StoneGateSetPrefix .. "_SGATE_RED_TILE_ROOF_MATERIAL")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Materials/murChateau", StoneGateSetPrefix .. "_SGATE_STONE_MANOR_WALL_MATERIAL")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_SGATE_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Materials/whiteStoneGround", StoneGateSetPrefix .. "_SGATE_WHITE_STONE_FLOOR_GROUND_MATERIAL")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Materials/whiteStoneFrame", StoneGateSetPrefix .. "_SGATE_WHITE_STONE_FRAME_MATERIAL")

-- Register Aligned Small Gate prefab nodes
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart", StoneGateSetPrefix .. "_SGATE_ROOT_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling1Part", StoneGateSetPrefix .. "_SGATE_TILING1_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling2Part", StoneGateSetPrefix .. "_SGATE_TILING2_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling3Part", StoneGateSetPrefix .. "_SGATE_TILING3_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_ext_Tiling1Part", StoneGateSetPrefix .. "_SGATE_EXT_TILING1_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootCPart", StoneGateSetPrefix .. "_SGATE_ROOTC_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootDPart", StoneGateSetPrefix .. "_SGATE_ROOTD_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_HalfRoofRootCPart", StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOTC_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_HalfRoofRootDPart", StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOTD_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BPart", StoneGateSetPrefix .. "_SGATE_TILING1B_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1CPart", StoneGateSetPrefix .. "_SGATE_TILING1C_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BEPart", StoneGateSetPrefix .. "_SGATE_TILING1BE_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1CEPart", StoneGateSetPrefix .. "_SGATE_TILING1CE_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling2BPart", StoneGateSetPrefix .. "_SGATE_TILING2B_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling3BPart", StoneGateSetPrefix .. "_SGATE_TILING3B_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootCPPart", StoneGateSetPrefix .. "_SGATE_ROOTCP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootDPPart", StoneGateSetPrefix .. "_SGATE_ROOTDP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BPPart", StoneGateSetPrefix .. "_SGATE_TILING1BP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1CPPart", StoneGateSetPrefix .. "_SGATE_TILING1CP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BEPPart", StoneGateSetPrefix .. "_SGATE_TILING1BEP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1CEPPart", StoneGateSetPrefix .. "_SGATE_TILING1CEP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling2BPPart", StoneGateSetPrefix .. "_SGATE_TILING2BP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling3BPPart", StoneGateSetPrefix .. "_SGATE_TILING3BP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_TopAPart", StoneGateSetPrefix .. "_SGATE_TOP_A_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_TopPart", StoneGateSetPrefix .. "_SGATE_TOP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofPart", StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOF_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofPPart", StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOFP_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofAPart", StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOFA_PREFAB")
StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofAPPart", StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOFAP_PREFAB")
--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	StoneGate:registerAsset({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		ConstructorData = {
                    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
                    CoreObjectPrefab = _nodePrefix .. "_PREFAB"
                },
                IsVisibleWhenBuilt = false, -- to mask the green diamond in top, only visible in preview
	        Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1*_NoSandbox }
		    },
		    ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		    }}
	        },
	        EstateSplendor = {
		    { Estate = "KINGDOM", Quantity = 0.1 }
	    }
	})
end

local defaultNodePrefixList = {
	StoneGateSetPrefix .. "_SGATE_TOP_A",
	StoneGateSetPrefix .. "_SGATE_TOP",
	StoneGateSetPrefix .. "_SGATE_TILING1",
	StoneGateSetPrefix .. "_SGATE_TILING2",
	StoneGateSetPrefix .. "_SGATE_TILING3",
	StoneGateSetPrefix .. "_SGATE_EXT_TILING1",
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList) do
	registerDefaultBuildingPart(nodePrefix)
end

function registerSmallGate(_option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING1B" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING1C" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING1BE" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING1CE" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING2B" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TILING3B" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOF" .. _option)
    registerDefaultBuildingPart(StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOFA" .. _option)

    -- Register the old stone gate set small gate root part with scaleable arch (kept for compatibility)
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_ROOT" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_ROOT" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_ROOT" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_ROOT_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1_PART"
         	},
		MinimumScale = 1,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })
   
    -- Register the stone gate set small gate root part with scaleable arch
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_ROOT_A" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_ROOT_A" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_ROOT_A" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_ROOT_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_A_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1_PART"
         	},
		MinimumScale = 1,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })

    -- Register the stone gate set small gate root part with scaleable upper part
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_ROOT_UPPER" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_ROOT_UPPER" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_ROOT_UPPER" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_ROOTC" .. _option .. "_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING3B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2B" .. _option .. "_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1C" .. _option .. "_PART"
         	},
		MinimumScale = 0,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })

    -- Register the stone gate set small gate extension root part
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_EXT_ROOT" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_EXT_ROOT" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_EXT_ROOT" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateExtensionBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_ROOTD" .. _option .. "_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING3B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2B" .. _option .. "_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1CE" .. _option .. "_PART"
         	},
		MinimumScale = 0,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })

    -- Register the stone gate set small gate root part with scaleable arch and half roof
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateHalfRoofBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_ROOT_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOFA" .. _option .. "_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART",
			StoneGateSetPrefix .. "_SGATE_TILING3_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1_PART"
         	},
		MinimumScale = 1,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })

    -- Register the stone gate set small gate root part with scaleable upper part and half roof
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT_UPPER" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT_UPPER" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOT_UPPER" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateHalfRoofBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOTC_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOF" .. _option .. "_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING3B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2B" .. _option .. "_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1C" .. _option .. "_PART"
         	},
		MinimumScale = 0,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })

    -- Register the stone gate set small gate extension root part with half roof
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_EXT_ROOT" .. _option .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_EXT_ROOT" .. _option .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_EXT_ROOT" .. _option .. "_DESC",
	Category = "CORE",
        BuildingZone = _SmallGateExtensionHalfRoofBuildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_HALF_ROOF_ROOTD_PREFAB",
		EndPart = StoneGateSetPrefix .. "_SGATE_TOP_HALF_ROOF" .. _option .. "_PART",
		FillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING3B" .. _option .. "_PART",
			StoneGateSetPrefix .. "_SGATE_TILING2B" .. _option .. "_PART"
                },
		BasementFillerList = {
			StoneGateSetPrefix .. "_SGATE_TILING1CE" .. _option .. "_PART"
         	},
		MinimumScale = 0,
		IsVertical = true,
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
    })
end

registerSmallGate("") -- with stone floor
registerSmallGate("P") -- with wooden floor

-- Register grass clearing components

StoneGate:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = { 4, 8 }
})
StoneGate:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootCPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = { 4, 8 }
})

function registerRampartPart(_nameFbx, _nameAsset, _resource, _buildingPartType)
    StoneGate:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_SGATE_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration rampart part
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_SGATE_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_SGATE_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_SGATE_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_SGATE_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = _resource, Quantity = 2*_NoSandbox }
		}}
	}
    })

    StoneGate:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _buildingPartType
    })
end

registerRampartPart( "step_4_SGate_RampartA", "RAMPART_A", "STONE", "MAJOR" )
registerRampartPart( "step_4_SGate_RampartClosingL", "RAMPART_CLOSING_L", "STONE", "MAJOR" )
registerRampartPart( "step_4_SGate_RampartClosingR", "RAMPART_CLOSING_R", "STONE", "MAJOR" )
registerRampartPart( "step_4_SGate_HalfRoof", "HALF_ROOF", "STONE", "MAJOR" )
registerRampartPart( "step_4_SGate_HalfRoofP", "HALF_ROOFP", "STONE", "MAJOR" )
registerRampartPart( "step_5_SGate_RoofA45", "ROOFA45", "PLANK", "MAJOR" )
registerRampartPart( "step_5_SGate_RoofA30", "ROOFA30", "PLANK", "MAJOR" )
registerRampartPart( "step_5_SGate_RoofA60", "ROOFA60", "PLANK", "MAJOR" )

-- platforms
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_TopPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofPPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofAPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_HalfRoofAPPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_4_SGate_HalfRoofPart", { "PLATFORM" })
StoneGate:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_4_SGate_HalfRoofPPart", { "PLATFORM" })

